import { ReactElement } from 'react';
import { InputProps } from '@mui/material';
import { AutocompleteItemProps } from './AutocompleteItem';
interface AutocompletePropsBase extends Omit<InputProps, 'value' | 'onChange' | 'children'> {
    searchLabel?: string;
    readonly?: boolean;
    children?: ReactElement<AutocompleteItemProps>[];
}
interface AutocompleteMultipleProps extends AutocompletePropsBase {
    multiple: true;
    value?: string[];
    onChange: (value: string[]) => void;
}
interface AutocompleteSimpleProps extends AutocompletePropsBase {
    multiple?: false;
    value?: string;
    onChange: (value: string) => void;
}
export declare type AutocompleteProps = AutocompleteMultipleProps | AutocompleteSimpleProps;
export declare const Autocomplete: ({ value, multiple, searchLabel, readonly, children, onChange }: AutocompleteProps) => JSX.Element;
export {};
