var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { useRef, useState } from 'react';
import { Avatar, Box, Chip, CircularProgress, Icon } from '@mui/material';
import { Btn } from '../Btn';
import { colorError } from '../_core/style/color';
import { makeSx } from '../_utils/common';
var sx = makeSx({
    doc_icon: {
        color: function (t) { return t.palette.text.secondary; },
        fontSize: function (t) { return t.typography.subtitle1.fontSize; },
    },
});
var defaultMsg = {
    loading: 'Loading...',
    upload: 'Upload',
    invalidSize: 'File is too big',
};
// TODO(Alex) Fix wierd typing issue (it works for <Btn>)
export var BtnUploader = function (_a) {
    var document = _a.document, uploading = _a.uploading, _b = _a.msg, msg = _b === void 0 ? defaultMsg : _b, onUpload = _a.onUpload, onDelete = _a.onDelete, maxUploadFileSize = _a.maxUploadFileSize, other = __rest(_a, ["document", "uploading", "msg", "onUpload", "onDelete", "maxUploadFileSize"]);
    var _c = useState(undefined), errorMessage = _c[0], setErrorMessage = _c[1];
    var fileInputEl = useRef(null);
    var openFileSelection = function () {
        fileInputEl.current.click();
    };
    var handleChange = function (files) {
        if (!files) {
            return;
        }
        var file = files[0];
        if (maxUploadFileSize && file.size > maxUploadFileSize * 1024 * 1024) {
            setErrorMessage(msg.invalidSize);
            return;
        }
        onUpload(file);
    };
    var clear = function () {
        onDelete();
    };
    var renderBody = function () {
        if (uploading) {
            return (React.createElement(Chip, { sx: {
                    color: function (t) { return t.palette.text.disabled; },
                    position: 'relative',
                }, label: msg.loading, avatar: React.createElement(Avatar, { style: { position: 'initial' } },
                    React.createElement(CircularProgress, { size: 32, sx: {
                            position: 'absolute',
                            top: 0,
                            right: 0,
                            left: 1,
                            bottom: 0,
                        } }),
                    React.createElement(Icon, { sx: sx.doc_icon }, "insert_drive_file")) }));
        }
        else {
            if (document) {
                return (React.createElement(Chip, { label: document.name, onDelete: clear, onClick: function () { return window.open(document.permalink, '_blank'); }, avatar: React.createElement(Avatar, null,
                        React.createElement(Icon, { sx: sx.doc_icon }, "insert_drive_file")) }));
            }
            else {
                return (React.createElement(Btn, __assign({ color: "primary", onClick: openFileSelection, icon: "file_upload" }, other),
                    msg.upload,
                    React.createElement("input", { style: { display: 'none' }, type: "file", ref: fileInputEl, onChange: function (e) { return handleChange(e.target.files); } })));
            }
        }
    };
    return (React.createElement(Box, { sx: {
            minHeight: 40,
            display: 'flex',
            alignItems: 'center',
        } },
        renderBody(),
        errorMessage &&
            React.createElement(Box, { sx: {
                    display: 'flex',
                    alignItems: 'center',
                    ml: 1,
                    color: colorError,
                    py: 1,
                    px: 2,
                    borderRadius: '2px',
                } },
                React.createElement(Icon, { sx: { mr: 1 } }, "warning"),
                errorMessage,
                React.createElement(Icon, { sx: {
                        ml: 1,
                        cursor: 'pointer',
                    }, onClick: function () { return setErrorMessage(''); } }, "clear"))));
};
