import * as React from 'react';
export declare const GlobalProgressContext: React.Context<IState>;
export declare const progressbarAnimationDuration = 400;
export interface IProgressState {
    currentStep: number;
    steps: number;
    started: boolean;
}
export interface GlobalProgressProviderProps {
}
export interface WithProgress {
    readonly progressStart: (steps?: number) => void;
    readonly progressStop: () => void;
    readonly progressComplete: () => void;
    readonly progressNext: () => void;
    readonly promisesWithProgress: (...promises: Promise<any>[]) => Promise<any>[];
}
export interface IState extends IProgressState, WithProgress {
}
declare class GlobalProgressProvider extends React.Component<GlobalProgressProviderProps, IState> {
    private timeouts;
    render(): JSX.Element;
    componentWillUnmount(): void;
    private readonly start;
    private readonly promisesWithProgress;
    private readonly stop;
    private readonly complete;
    private readonly next;
    readonly state: {
        currentStep: number;
        steps: number;
        started: boolean;
        progressStart: (steps?: number) => void;
        progressStop: () => void;
        progressComplete: () => void;
        progressNext: () => void;
        promisesWithProgress: (...promises: Promise<any>[]) => Promise<any>[];
    };
    private stopHandlingAnimation;
    private setTimeout;
    private clearTimeouts;
}
export default GlobalProgressProvider;
export declare const useGlobalProgress: () => WithProgress;
export declare const useGlobalProgressState: () => IProgressState;
export declare const withGlobalProgress: (Component: any) => (props: any) => JSX.Element;
