import { EventHandler, ReactElement, ReactNode, SyntheticEvent } from 'react';
import { DialogProps, PaperProps } from '@mui/material';
export interface ModalProps extends Omit<DialogProps, 'children' | 'onClick' | 'open'> {
    disabled?: boolean;
    title?: string;
    confirmLabel?: string;
    cancelLabel?: string;
    content?: ((content: () => void) => ReactNode) | ReactNode | string;
    children: ReactElement<any>;
    onOpen?: () => void;
    onClose?: () => void;
    onConfirm?: (event: SyntheticEvent<any>, close: () => void) => void;
    confirmDisabled?: boolean;
    onClick?: EventHandler<SyntheticEvent<any>>;
    PaperProps?: Partial<PaperProps>;
    loading?: boolean;
    overrideActions?: (_: () => void) => ReactNode;
}
export declare const Modal: ({ overrideActions, children, title, content, confirmLabel, cancelLabel, onConfirm, onClick, onOpen, onClose, confirmDisabled, loading, PaperProps, ...props }: ModalProps) => JSX.Element;
