var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { useState } from 'react';
import { Button, Dialog, DialogActions, DialogContent, DialogTitle, LinearProgress } from '@mui/material';
var enterKeyCode = 13;
export var Modal = function (_a) {
    var overrideActions = _a.overrideActions, children = _a.children, title = _a.title, content = _a.content, confirmLabel = _a.confirmLabel, cancelLabel = _a.cancelLabel, onConfirm = _a.onConfirm, onClick = _a.onClick, onOpen = _a.onOpen, onClose = _a.onClose, confirmDisabled = _a.confirmDisabled, loading = _a.loading, PaperProps = _a.PaperProps, props = __rest(_a, ["overrideActions", "children", "title", "content", "confirmLabel", "cancelLabel", "onConfirm", "onClick", "onOpen", "onClose", "confirmDisabled", "loading", "PaperProps"]);
    var _b = useState(false), isOpen = _b[0], setIsOpen = _b[1];
    var open = function () {
        onOpen === null || onOpen === void 0 ? void 0 : onOpen();
        setIsOpen(true);
    };
    var close = function () {
        onClose === null || onClose === void 0 ? void 0 : onClose();
        setIsOpen(false);
    };
    var confirm = function (event) {
        if (onConfirm)
            onConfirm(event, close);
    };
    var handleKeypress = function (e) {
        if (e.keyCode === enterKeyCode) {
            confirm(e);
        }
    };
    return (React.createElement(React.Fragment, null,
        React.cloneElement(children, {
            onClick: function (event) {
                if (children.props.onClick)
                    children.props.onClick(event);
                if (onClick)
                    onClick(event);
                open();
            }
        }),
        React.createElement(Dialog, __assign({ open: isOpen }, props, { PaperProps: PaperProps }),
            loading && (React.createElement(LinearProgress, { sx: {
                    position: 'absolute',
                    top: 0,
                    right: 0,
                    left: 0,
                } })),
            React.createElement(DialogTitle, null, title),
            React.createElement(DialogContent, null, (typeof content === 'function') ? content(close) : content),
            React.createElement(DialogActions, null, overrideActions ? overrideActions(close) : (React.createElement(React.Fragment, null,
                React.createElement(Button, { color: "primary", onClick: close }, cancelLabel || 'Cancel'),
                onConfirm && (React.createElement(Button, { color: "primary", onClick: confirm, disabled: confirmDisabled }, confirmLabel || 'Confirm'))))))));
};
