var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { Box } from '@mui/material';
import { MobileHeader } from './MobileHeader/MobileHeader';
import { LayoutProvider, useLayoutContext } from './LayoutContext';
export var sidebarWith = 220;
export var Layout = function (_a) {
    var title = _a.title, mobileBreakpoint = _a.mobileBreakpoint, children = _a.children, sidebar = _a.sidebar, rest = __rest(_a, ["title", "mobileBreakpoint", "children", "sidebar"]);
    return (React.createElement(LayoutProvider, { title: title, mobileBreakpoint: mobileBreakpoint },
        React.createElement(LayoutUsingContext, __assign({ sidebar: sidebar }, rest), children)));
};
var LayoutUsingContext = function (_a) {
    var children = _a.children, Sidebar = _a.sidebar, sx = _a.sx, rest = __rest(_a, ["children", "sidebar", "sx"]);
    var isMobileWidth = useLayoutContext().isMobileWidth;
    return (React.createElement(React.Fragment, null,
        React.createElement(MobileHeader, null),
        React.createElement(Box, __assign({ sx: __assign({ overflow: 'hidden', position: 'relative', display: 'flex' }, !isMobileWidth && {
                marginLeft: sidebarWith + 'px',
            }) }, rest),
            Sidebar && React.createElement(Sidebar, null),
            children)));
};
