import * as React from 'react';
import { createContext, useContext, useEffect, useState } from 'react';
// import debounce from 'lodash.debounce'
var LayoutContext = createContext({});
export var LayoutProvider = function (_a) {
    var title = _a.title, _b = _a.mobileBreakpoint, mobileBreakpoint = _b === void 0 ? 700 : _b, children = _a.children;
    var _c = useState(false), isMobileSidebarOpened = _c[0], setIsMobileSidebarOpened = _c[1];
    var _d = useState(getWidth()), mobileWidth = _d[0], setMobileWidth = _d[1];
    var openMobileSidebar = function () { return setIsMobileSidebarOpened(true); };
    var closeMobileSidebar = function () { return setIsMobileSidebarOpened(false); };
    var toggleMobileSidebar = function () { return setIsMobileSidebarOpened(!isMobileSidebarOpened); };
    useEffect(function () {
        window.addEventListener('resize', function () { return setMobileWidth(getWidth()); });
        // window.addEventListener('resize', debounce(() => setMobileWidth(getWidth()), 600))
    }, []);
    return (React.createElement(LayoutContext.Provider, { value: {
            isMobileSidebarOpened: isMobileSidebarOpened,
            openMobileSidebar: openMobileSidebar,
            closeMobileSidebar: closeMobileSidebar,
            toggleMobileSidebar: toggleMobileSidebar,
            title: title,
            isMobileWidth: mobileWidth < mobileBreakpoint,
        } }, children));
};
function getWidth() {
    return window.innerWidth;
}
export var useLayoutContext = function () {
    return useContext(LayoutContext);
};
