"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSetState = void 0;
var react_1 = require("react");
var useSetState = function (initialValue) {
    if (initialValue === void 0) { initialValue = []; }
    var _a = (0, react_1.useState)(new Set(initialValue)), set = _a[0], setSet = _a[1];
    var add = function (t) {
        if (Array.isArray(t)) {
            var newSet = new Set(t);
            setSet(newSet);
        }
        else {
            set.add(t);
            var newSet = new Set(set);
            setSet(newSet);
        }
    };
    var remove = function (t) {
        var returnValue = set.delete(t);
        setSet(new Set(set));
        return returnValue;
    };
    var clear = function () { return setSet(new Set()); };
    return {
        has: function (t) { return set.has(t); },
        size: set.size,
        values: function () { return set.values(); },
        toArray: function () { return Array.from(set.values()); },
        add: add,
        delete: remove,
        clear: clear,
    };
};
exports.useSetState = useSetState;
//# sourceMappingURL=useSetState.js.map